%# BEGIN BPS TAGGED BLOCK {{{
%#
%# COPYRIGHT:
%#
%# This software is Copyright (c) 1996-2023 Best Practical Solutions, LLC
%#                                          <sales@bestpractical.com>
%#
%# (Except where explicitly superseded by other copyright notices)
%#
%#
%# LICENSE:
%#
%# This work is made available to you under the terms of Version 2 of
%# the GNU General Public License. A copy of that license should have
%# been provided with this software, but in any event can be snarfed
%# from www.gnu.org.
%#
%# This work is distributed in the hope that it will be useful, but
%# WITHOUT ANY WARRANTY; without even the implied warranty of
%# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%# General Public License for more details.
%#
%# You should have received a copy of the GNU General Public License
%# along with this program; if not, write to the Free Software
%# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
%# 02110-1301 or visit their web page on the internet at
%# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html.
%#
%#
%# CONTRIBUTION SUBMISSION POLICY:
%#
%# (The following paragraph is not intended to limit the rights granted
%# to you to modify and distribute this software under the terms of
%# the GNU General Public License and is only of importance to you if
%# you choose to contribute your changes and enhancements to the
%# community by submitting them to Best Practical Solutions, LLC.)
%#
%# By intentionally submitting any modifications, corrections or
%# derivatives to this work, or any other work intended for use with
%# Request Tracker, to Best Practical Solutions, LLC, you confirm that
%# you are the copyright holder for those contributions and you grant
%# Best Practical Solutions,  LLC a nonexclusive, worldwide, irrevocable,
%# royalty-free, perpetual, license to use, copy, create derivative
%# works based on those contributions, and sublicense and distribute
%# those contributions and any derivatives thereof.
%#
%# END BPS TAGGED BLOCK }}}
<& /Elements/Header, Title => loc('User Search'), Focus => '#autocomplete-UserString' &>
<& /Elements/Tabs &>
    
<& /Elements/GotoUser, Default => $UserString||'' &>

<p> <&|/l&>This will search for users by looking in the following fields:</&> <% $search_fields %></p>

% if ($UserString) {

% unless ( $users->Count ) {
<p><&|/l&>No users matching search criteria found.</&></p>
% } else {
<p><&|/l&>Select a user</&>:</p>

<& /Elements/CollectionList,
    OrderBy => 'Name',
    Order => 'ASC',
    Rows  => 100,
    %ARGS,
    Format => $Format,
    Collection => $users,
    AllowSorting => 1,
    PassArguments => [qw(Format Rows Page Order OrderBy UserString)],
&>

% }
% }

<%INIT>

my $users;
my $Format;
if ( $UserString ) {
    my $exclude = [RT->Nobody->Id, RT->System->Id];
    $users = RT::Users->new($session{'CurrentUser'});
    $users->SimpleSearch( Return    => 'Name',
                          Term      => $UserString,
                          Max       => 100,
                          Exclude   => $exclude );
    my $first = $users->First;
    RT::Interface::Web::Redirect(RT->Config->Get('WebURL')."User/Summary.html?id=".$first->Id)
        if $users->Count == 1;
    $users->GotoFirstItem;
    $Format = RT->Config->Get('UserSearchResultFormat');
}

my $search_fields = join ", ",
  sort map {s/^CF\.(?:\{(.*)}|(.*))/$1 || $2/e; loc($_)}
  keys %{RT->Config->Get('UserSearchFields')};

</%INIT>
<%ARGS>
$UserString => undef
</%ARGS>
